/*******************************************************************************
* 
* "This software program is licensed subject to the GNU General Public License 
* (GPL). Version 2, June 1991, available at 
* <http://www.fsf.org/copyleft/gpl.html>"
* 
* GNU General Public License 
* 
* Version 2, June 1991
* 
* Copyright (C) 1989, 1991 Free Software Foundation, Inc.  
* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
* 
* Everyone is permitted to copy and distribute verbatim copies of this license
* document, but changing it is not allowed.
* 
* Preamble
* 
* The licenses for most software are designed to take away your freedom to 
* share and change it. By contrast, the GNU General Public License is intended
* to guarantee your freedom to share and change free software--to make sure 
* the software is free for all its users. This General Public License applies 
* to most of the Free Software Foundation's software and to any other program 
* whose authors commit to using it. (Some other Free Software Foundation 
* software is covered by the GNU Library General Public License instead.) You 
* can apply it to your programs, too.
* 
* When we speak of free software, we are referring to freedom, not price. Our
* General Public Licenses are designed to make sure that you have the freedom 
* to distribute copies of free software (and charge for this service if you 
* wish), that you receive source code or can get it if you want it, that you 
* can change the software or use pieces of it in new free programs; and that 
* you know you can do these things.
* 
* To protect your rights, we need to make restrictions that forbid anyone to 
* deny you these rights or to ask you to surrender the rights. These 
* restrictions translate to certain responsibilities for you if you distribute
* copies of the software, or if you modify it.
* 
* For example, if you distribute copies of such a program, whether gratis or 
* for a fee, you must give the recipients all the rights that you have. You 
* must make sure that they, too, receive or can get the source code. And you 
* must show them these terms so they know their rights.
*  
* We protect your rights with two steps: (1) copyright the software, and (2) 
* offer you this license which gives you legal permission to copy, distribute 
* and/or modify the software. 
* 
* Also, for each author's protection and ours, we want to make certain that 
* everyone understands that there is no warranty for this free software. If 
* the software is modified by someone else and passed on, we want its 
* recipients to know that what they have is not the original, so that any 
* problems introduced by others will not reflect on the original authors' 
* reputations. 
* 
* Finally, any free program is threatened constantly by software patents. We 
* wish to avoid the danger that redistributors of a free program will 
* individually obtain patent licenses, in effect making the program 
* proprietary. To prevent this, we have made it clear that any patent must be 
* licensed for everyone's free use or not licensed at all. 
* 
* The precise terms and conditions for copying, distribution and modification 
* follow. 
* 
* TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
* 
* 0. This License applies to any program or other work which contains a notice
*    placed by the copyright holder saying it may be distributed under the 
*    terms of this General Public License. The "Program", below, refers to any
*    such program or work, and a "work based on the Program" means either the 
*    Program or any derivative work under copyright law: that is to say, a 
*    work containing the Program or a portion of it, either verbatim or with 
*    modifications and/or translated into another language. (Hereinafter, 
*    translation is included without limitation in the term "modification".) 
*    Each licensee is addressed as "you". 
* 
*    Activities other than copying, distribution and modification are not 
*    covered by this License; they are outside its scope. The act of running 
*    the Program is not restricted, and the output from the Program is covered 
*    only if its contents constitute a work based on the Program (independent 
*    of having been made by running the Program). Whether that is true depends
*    on what the Program does. 
* 
* 1. You may copy and distribute verbatim copies of the Program's source code 
*    as you receive it, in any medium, provided that you conspicuously and 
*    appropriately publish on each copy an appropriate copyright notice and 
*    disclaimer of warranty; keep intact all the notices that refer to this 
*    License and to the absence of any warranty; and give any other recipients 
*    of the Program a copy of this License along with the Program. 
* 
*    You may charge a fee for the physical act of transferring a copy, and you 
*    may at your option offer warranty protection in exchange for a fee. 
* 
* 2. You may modify your copy or copies of the Program or any portion of it, 
*    thus forming a work based on the Program, and copy and distribute such 
*    modifications or work under the terms of Section 1 above, provided that 
*    you also meet all of these conditions: 
* 
*    * a) You must cause the modified files to carry prominent notices stating 
*         that you changed the files and the date of any change. 
* 
*    * b) You must cause any work that you distribute or publish, that in 
*         whole or in part contains or is derived from the Program or any part 
*         thereof, to be licensed as a whole at no charge to all third parties
*         under the terms of this License. 
* 
*    * c) If the modified program normally reads commands interactively when 
*         run, you must cause it, when started running for such interactive 
*         use in the most ordinary way, to print or display an announcement 
*         including an appropriate copyright notice and a notice that there is
*         no warranty (or else, saying that you provide a warranty) and that 
*         users may redistribute the program under these conditions, and 
*         telling the user how to view a copy of this License. (Exception: if 
*         the Program itself is interactive but does not normally print such 
*         an announcement, your work based on the Program is not required to 
*         print an announcement.) 
* 
*    These requirements apply to the modified work as a whole. If identifiable 
*    sections of that work are not derived from the Program, and can be 
*    reasonably considered independent and separate works in themselves, then 
*    this License, and its terms, do not apply to those sections when you 
*    distribute them as separate works. But when you distribute the same 
*    sections as part of a whole which is a work based on the Program, the 
*    distribution of the whole must be on the terms of this License, whose 
*    permissions for other licensees extend to the entire whole, and thus to 
*    each and every part regardless of who wrote it. 
* 
*    Thus, it is not the intent of this section to claim rights or contest 
*    your rights to work written entirely by you; rather, the intent is to 
*    exercise the right to control the distribution of derivative or 
*    collective works based on the Program. 
* 
*    In addition, mere aggregation of another work not based on the Program 
*    with the Program (or with a work based on the Program) on a volume of a 
*    storage or distribution medium does not bring the other work under the 
*    scope of this License. 
* 
* 3. You may copy and distribute the Program (or a work based on it, under 
*    Section 2) in object code or executable form under the terms of Sections 
*    1 and 2 above provided that you also do one of the following: 
* 
*    * a) Accompany it with the complete corresponding machine-readable source 
*         code, which must be distributed under the terms of Sections 1 and 2 
*         above on a medium customarily used for software interchange; or, 
* 
*    * b) Accompany it with a written offer, valid for at least three years, 
*         to give any third party, for a charge no more than your cost of 
*         physically performing source distribution, a complete machine-
*         readable copy of the corresponding source code, to be distributed 
*         under the terms of Sections 1 and 2 above on a medium customarily 
*         used for software interchange; or, 
* 
*    * c) Accompany it with the information you received as to the offer to 
*         distribute corresponding source code. (This alternative is allowed 
*         only for noncommercial distribution and only if you received the 
*         program in object code or executable form with such an offer, in 
*         accord with Subsection b above.) 
* 
*    The source code for a work means the preferred form of the work for 
*    making modifications to it. For an executable work, complete source code 
*    means all the source code for all modules it contains, plus any 
*    associated interface definition files, plus the scripts used to control 
*    compilation and installation of the executable. However, as a special 
*    exception, the source code distributed need not include anything that is 
*    normally distributed (in either source or binary form) with the major 
*    components (compiler, kernel, and so on) of the operating system on which
*    the executable runs, unless that component itself accompanies the 
*    executable. 
* 
*    If distribution of executable or object code is made by offering access 
*    to copy from a designated place, then offering equivalent access to copy 
*    the source code from the same place counts as distribution of the source 
*    code, even though third parties are not compelled to copy the source 
*    along with the object code. 
* 
* 4. You may not copy, modify, sublicense, or distribute the Program except as
*    expressly provided under this License. Any attempt otherwise to copy, 
*    modify, sublicense or distribute the Program is void, and will 
*    automatically terminate your rights under this License. However, parties 
*    who have received copies, or rights, from you under this License will not
*    have their licenses terminated so long as such parties remain in full 
*    compliance. 
* 
* 5. You are not required to accept this License, since you have not signed 
*    it. However, nothing else grants you permission to modify or distribute 
*    the Program or its derivative works. These actions are prohibited by law 
*    if you do not accept this License. Therefore, by modifying or 
*    distributing the Program (or any work based on the Program), you 
*    indicate your acceptance of this License to do so, and all its terms and
*    conditions for copying, distributing or modifying the Program or works 
*    based on it. 
* 
* 6. Each time you redistribute the Program (or any work based on the 
*    Program), the recipient automatically receives a license from the 
*    original licensor to copy, distribute or modify the Program subject to 
*    these terms and conditions. You may not impose any further restrictions 
*    on the recipients' exercise of the rights granted herein. You are not 
*    responsible for enforcing compliance by third parties to this License. 
* 
* 7. If, as a consequence of a court judgment or allegation of patent 
*    infringement or for any other reason (not limited to patent issues), 
*    conditions are imposed on you (whether by court order, agreement or 
*    otherwise) that contradict the conditions of this License, they do not 
*    excuse you from the conditions of this License. If you cannot distribute 
*    so as to satisfy simultaneously your obligations under this License and 
*    any other pertinent obligations, then as a consequence you may not 
*    distribute the Program at all. For example, if a patent license would 
*    not permit royalty-free redistribution of the Program by all those who 
*    receive copies directly or indirectly through you, then the only way you 
*    could satisfy both it and this License would be to refrain entirely from 
*    distribution of the Program. 
* 
*    If any portion of this section is held invalid or unenforceable under any
*    particular circumstance, the balance of the section is intended to apply
*    and the section as a whole is intended to apply in other circumstances. 
* 
*    It is not the purpose of this section to induce you to infringe any 
*    patents or other property right claims or to contest validity of any 
*    such claims; this section has the sole purpose of protecting the 
*    integrity of the free software distribution system, which is implemented 
*    by public license practices. Many people have made generous contributions
*    to the wide range of software distributed through that system in 
*    reliance on consistent application of that system; it is up to the 
*    author/donor to decide if he or she is willing to distribute software 
*    through any other system and a licensee cannot impose that choice. 
* 
*    This section is intended to make thoroughly clear what is believed to be 
*    a consequence of the rest of this License. 
* 
* 8. If the distribution and/or use of the Program is restricted in certain 
*    countries either by patents or by copyrighted interfaces, the original 
*    copyright holder who places the Program under this License may add an 
*    explicit geographical distribution limitation excluding those countries, 
*    so that distribution is permitted only in or among countries not thus 
*    excluded. In such case, this License incorporates the limitation as if 
*    written in the body of this License. 
* 
* 9. The Free Software Foundation may publish revised and/or new versions of 
*    the General Public License from time to time. Such new versions will be 
*    similar in spirit to the present version, but may differ in detail to 
*    address new problems or concerns. 
* 
*    Each version is given a distinguishing version number. If the Program 
*    specifies a version number of this License which applies to it and "any 
*    later version", you have the option of following the terms and 
*    conditions either of that version or of any later version published by 
*    the Free Software Foundation. If the Program does not specify a version 
*    number of this License, you may choose any version ever published by the 
*    Free Software Foundation. 
* 
* 10. If you wish to incorporate parts of the Program into other free programs
*     whose distribution conditions are different, write to the author to ask 
*     for permission. For software which is copyrighted by the Free Software 
*     Foundation, write to the Free Software Foundation; we sometimes make 
*     exceptions for this. Our decision will be guided by the two goals of 
*     preserving the free status of all derivatives of our free software and 
*     of promoting the sharing and reuse of software generally. 
* 
*    NO WARRANTY
* 
* 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY 
*     FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN 
*     OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES 
*     PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER 
*     EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
*     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE 
*     ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH 
*     YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL 
*     NECESSARY SERVICING, REPAIR OR CORRECTION. 
* 
* 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING 
*     WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR 
*     REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR 
*     DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL 
*     DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM 
*     (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
*     INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF 
*     THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR 
*     OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. 
* 
* END OF TERMS AND CONDITIONS
* 
* How to Apply These Terms to Your New Programs
* 
* If you develop a new program, and you want it to be of the greatest 
* possible use to the public, the best way to achieve this is to make it free 
* software which everyone can redistribute and change under these terms. 
* 
* To do so, attach the following notices to the program. It is safest to 
* attach them to the start of each source file to most effectively convey the
* exclusion of warranty; and each file should have at least the "copyright" 
* line and a pointer to where the full notice is found. 
* 
* one line to give the program's name and an idea of what it does.
* Copyright (C) yyyy  name of author
* 
* This program is free software; you can redistribute it and/or modify it 
* under the terms of the GNU General Public License as published by the Free 
* Software Foundation; either version 2 of the License, or (at your option) 
* any later version.
* 
* This program is distributed in the hope that it will be useful, but WITHOUT 
* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
* more details.
* 
* You should have received a copy of the GNU General Public License along with
* this program; if not, write to the Free Software Foundation, Inc., 59 
* Temple Place - Suite 330, Boston, MA  02111-1307, USA.
* 
* Also add information on how to contact you by electronic and paper mail. 
* 
* If the program is interactive, make it output a short notice like this when 
* it starts in an interactive mode: 
* 
* Gnomovision version 69, Copyright (C) year name of author Gnomovision comes 
* with ABSOLUTELY NO WARRANTY; for details type 'show w'.  This is free 
* software, and you are welcome to redistribute it under certain conditions; 
* type 'show c' for details.
* 
* The hypothetical commands 'show w' and 'show c' should show the appropriate 
* parts of the General Public License. Of course, the commands you use may be 
* called something other than 'show w' and 'show c'; they could even be 
* mouse-clicks or menu items--whatever suits your program. 
* 
* You should also get your employer (if you work as a programmer) or your 
* school, if any, to sign a "copyright disclaimer" for the program, if 
* necessary. Here is a sample; alter the names: 
* 
* Yoyodyne, Inc., hereby disclaims all copyright interest in the program 
* 'Gnomovision' (which makes passes at compilers) written by James Hacker.
* 
* signature of Ty Coon, 1 April 1989
* Ty Coon, President of Vice
* 
* This General Public License does not permit incorporating your program into 
* proprietary programs. If your program is a subroutine library, you may 
* consider it more useful to permit linking proprietary applications with the 
* library. If this is what you want to do, use the GNU Library General Public 
* License instead of this License.
*******************************************************************************/

/*****************************************************************************
******************************************************************************
**                                                                          **
** INTEL CORPORATION                                                        **
**                                                                          **
** This software is supplied under the terms of the license included        **
** above.  All use of this software must be in accordance with the terms    **
** of that license.                                                         **
**                                                                          **
** THIS FILE IS USED WHEN CREATING ians_core.o. HENCE, IT SHOULD NOT BE     **
** MODIFIED!                                                                **
**                                                                          **
**  Module Name:    base_comm.h                                             **
**                                                                          **
**  Abstract:       This header file defines the communications between     **
**                  iANS module and the base driversbound below it.         **
**                                                                          **
**  Environment:    Kernel Mode (linux 2.2.x, 2.4.x)                        **
**                                                                          **
**                  Written using Tab Size = 4, Indent Size = 4             **
**                                                                          **
**  Revision History:                                                       **
**                                                                          **
******************************************************************************
*****************************************************************************/

#ifndef _BASE_COMM_H
#define _BASE_COMM_H

#define UINT16 __u16
#define UINT32 __u32
#define UCHAR __u8

// Make sure all communications parties use the same packing mode
// for the shared structures.
#ifdef __ia64__
 #pragma pack(8)
#else
 #pragma pack(4)
#endif


/*------------------------------------------------------------------*
| Communication version :
| this is the version of the communication protocol described in
| this header file.
| This information will be passed in the IANS_BD_IDENTIFY ioctl
*------------------------------------------------------------------*/

// iANS's communications version
#define IANS_COMM_VERSION_MAJOR (UINT16)1
#define IANS_COMM_VERSION_MINOR (UINT16)0

// Base driver's version
#define IANS_BD_COMM_VERSION_MAJOR (UINT16)1
#define IANS_BD_COMM_VERSION_MINOR (UINT16)0

#define IANS_SIGNATURE_LENGTH 80

#ifdef _IANS_MAIN_MODULE_C_
char IntelCopyrightString[IANS_SIGNATURE_LENGTH] =
    "Intel Copyright 1999, all rights reserved\n";
#else //_IANS_MAIN_MODULE_C_
extern char IntelCopyrightString[IANS_SIGNATURE_LENGTH];
#endif //_IANS_MAIN_MODULE_C_


/*==========================================================================*
*                                                                           *
* IOCTLs                                                                    *
*                                                                           *
*==========================================================================*/


/*--------------------------------------------------------------------*
 | Proprietary Opcodes
 *--------------------------------------------------------------------*/
typedef enum _IANS_BASE_OPCODE {

    // ---------- Basic Extension Commands ---------- //
    IANS_OP_BD_IDENTIFY,                // Identify BD to make sure it supports iANS comm.
                                        // BD fills Struct: IANS_BD_PARAM_IDENTIFY
    IANS_OP_BD_DISCONNECT,              // Tell the BD that iANS is about to unload
    IANS_OP_EXT_GET_CAPABILITY,         // Get extended capabilities
                                        // BD fills struct: _IANS_BD_PARAM_EXT_CAP
    IANS_OP_EXT_SET_MODE,               // Set extended capabilities
                                        // iANS fills struct: _IANS_BD_PARAM_EXT_SET_MODE
    IANS_OP_EXT_GET_STATUS,             // Get status from base driver
                                        // BD fills status struct: IANS_BD_IOC_PARAM_STATUS
    IANS_OP_ANS_SET_CB,                 // pass ans function's pointers to base

    // ---------- Adapter Teaming Commands ---------- //
    IANS_OP_IAT_FIRST=0x0100,           // Skip over reserved area
                                        // There are no commands specific to adapter teaming
                                        // Capabilities are included in "Extended capabilities"

    // ---------- VLan Tagging Commands ---------- //
    IANS_OP_ITAG_FIRST=0x0200,          // Skip over reserved area
    IANS_OP_ITAG_GET_CAPABILITY,        // Get tagging capabilities
                                        // BD fills struct: IANS_BD_PARAM_ITAG_CAP
    IANS_OP_ITAG_SET_MODE,              // None/ISL/802.3ac
                                        // IANS fills struct: IANS_BD_PARAM_ITAG_SET_MODE

    // ---------- VLan ID Commands ---------- //
    IANS_OP_IVLAN_ID_FIRST=0x0300,      // Skip over reserved area
    IANS_OP_IVLAN_ID_GET_CAPABILITY,    // Get VLan ID capabilities
                                        // BD fills struct: IANS_BD_PARAM_IVLAN_CAP
    IANS_OP_IVLAN_ID_SET_MODE,          // Set Vlan ID mode
                                        // iANS fills struct: IANS_BD_PARAM_IVLAN_SET_MODE
    IANS_OP_IVLAN_ID_SET_TABLE,         // ID list
                                        // iANS fills struct: IANS_BD_PARAM_IVLAN_TABLE
    IANS_OP_COMMA                       // Dummy to satisfy last ifdef'ed commma
} IANS_BASE_OPCODE, *PIANS_BASE_OPCODE;


/*--------------------------------------------------------------------*
 | Enumerated types for field values
 *--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*
 | Enumerated types for Status struct field values
 *--------------------------------------------------------------------*
 | In every field, if a base driver doesn't support a valid indication
 | on that field it should set it to zero. This value was picked in
 | every enumerated type to denote "not supported" value.
 *--------------------------------------------------------------------*/

// Used in IANS_BD_PARAM_STATUS.LinkStatus
typedef enum _IANS_BD_LINK_STATUS {
    IANS_STATUS_LINK_NOT_SUPPORTED = 0,
    IANS_STATUS_LINK_OK,
    IANS_STATUS_LINK_FAIL
} IANS_BD_LINK_STATUS, *PIANS_BD_LINK_STATUS;

// Used in IANS_BD_PARAM_STATUS.Duplex
typedef enum _IANS_BD_DUPLEX_STATUS {
    IANS_STATUS_DUPLEX_NOT_SUPPORTED = 0,
    IANS_STATUS_DUPLEX_HALF,
    IANS_STATUS_DUPLEX_FULL
} IANS_BD_DUPLEX_STATUS, *PIANS_BD_DUPLEX_STATUS;

// Used in IANS_BD_PARAM_STATUS.LinkSpeed
typedef enum _IANS_BD_LINK_SPEED {
    IANS_STATUS_LINK_SPEED_NOT_SUPPORTED    = 0,
    IANS_STATUS_LINK_SPEED_1MBPS            = 0x1,
    IANS_STATUS_LINK_SPEED_10MBPS           = 0x2,
    IANS_STATUS_LINK_SPEED_100MBPS          = 0x4,
    IANS_STATUS_LINK_SPEED_1000MBPS         = 0x8,
    IANS_STATUS_LINK_SPEED_10000MBPS        = 0x10
}IANS_BD_LINK_SPEED, *PIANS_BD_LINK_SPEED;

// Used in IANS_BD_PARAM_STATUS.HardwareFailure
typedef enum _IANS_BD_HW_STATUS {
    IANS_STATUS_HARDWARE_NOT_SUPPORTED = 0,
    IANS_STATUS_HARDWARE_OK,
    IANS_STATUS_HARDWARE_FAILURE
} IANS_BD_HW_STATUS, *PIANS_BD_HW_STATUS;

// Used in IANS_BD_PARAM_STATUS.DuringResetProcess
typedef enum _IANS_BD_RESET_STAGE {
    IANS_STATUS_RESET_NOT_SUPPORTED =0,
    IANS_STATUS_NOT_DURING_RESET,
    IANS_STATUS_DURING_RESET
} IANS_BD_RESET_STAGE, *PIANS_BD_RESET_STAGE;

// Used in IANS_BD_PARAM_STATUS.Suspended
typedef enum _IANS_BD_SUSPENDED_STAGE {
    IANS_STATUS_SUSPENDED_NOT_SUPPORTED =0,
    IANS_STATUS_NOT_SUSPENDED,
    IANS_STATUS_SUSPENDED
} IANS_BD_SUSPENDED_STAGE, *PIANS_BD_SUSPENDED_STAGE;

// Rx and event notification routing mechanisms(bitmask ready)
typedef enum _IANS_BD_ROUTING {
    IANS_ROUTING_NOT_SUPPORTED  = 0x00,
    IANS_ROUTING_RX_PROTOCOL    = 0x01,
} IANS_BD_ROUTING, *PIANS_BD_ROUTING;

typedef enum _IANS_BD_HOT_PLUG_STATUS {
    IANS_STATUS_HOT_PLUG_NOT_SUPPORTED = 0,
    IANS_STATUS_HOT_PLUG_NOT_DONE,
    IANS_STATUS_HOT_PLUG_WAS_DONE
} IANS_BD_HOT_PLUG_STATUS, *PIANS_BD_HOT_PLUG_STATUS;


/*--------------------------------------------------------------------*
 | Enumerated types for general structs field values
 *--------------------------------------------------------------------*/

// general typedef for various features - whether BD supports a feature
// or not. To be used on "capabilites" structs
typedef enum _IANS_BD_SUPPORT {
    IANS_BD_DOES_NOT_SUPPORT = 0,
    IANS_BD_SUPPORTS
} IANS_BD_SUPPORT, *PIANS_BD_SUPPORT;

// general typedef for various features - whether iANS requests the BD
// to support a feature or not. To be used on "set mode" structs.
typedef enum _IANS_BD_REQUEST_SUPPORT {
    IANS_DONT_SUPPORT = 0,
    IANS_REQUEST_SUPPORT
} IANS_BD_REQUEST_SUPPORT, *PIANS_BD_REQUEST_SUPPORT;


/*--------------------------------------------------------------------*
 | Ioctl parameter structs
 | =======================
 | The following structures are used by the different IOCTLs to pass
 | parameters between the Base driver and iANS.
 *--------------------------------------------------------------------*/

/*--------------------------------------------------------------------*
 | Common Command/Parameter Header
 | ===============================
 | The 1st field of every parameter struct.
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_HEADER {
    // Cast from IANS_BASE_OPCODE to insure forward size compatibility
    int Opcode;
} IANS_BD_PARAM_HEADER, *PIANS_BD_PARAM_HEADER;

/*--------------------------------------------------------------------*
 | Status result
 | =============
 | This struct is sent with as a response to GET_STATUS request.
 | The status struct contains a version number : in case we will wish to
 | extend the status result, we will need a way to indicate which
 | version of the status struct we support.
 *--------------------------------------------------------------------*/
#define IANS_STATUS_VERSION 0x00000001

typedef struct _IANS_BD_PARAM_STATUS {
    UINT32 StatusVersion;       // The version of this struct
    UINT32 LinkStatus;          // Cast from IANS_BD_LINK_STATUS
    UINT32 LinkSpeed;           // Cast from IANS_BD_LINK_SPEED
    UINT32 Duplex;              // Cast from IANS_BD_DUPLEX_STATUS
    UINT32 HardwareFailure;     // Cast from IANS_BD_HW_FAILURE
    UINT32 DuringResetProcess;  // Cast from IANS_BD_RESET_STAGE
    UINT32 Suspended;           // Cast from IANS_BD_SUSPENDED_STAGE
    UINT32 HotPlug;             // Cast from IANS_BD_HOT_PLUG_STATUS
} IANS_BD_PARAM_STATUS, *PIANS_BD_PARAM_STATUS;

/*--------------------------------------------------------------------*
 | Status ioctl result
 | ===================
 | This structure is the struct sent as a response to the GET_STATUS
 | request ioctl. It contains the ioctl header, and the status struct.
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_IOC_PARAM_STATUS {
    IANS_BD_PARAM_HEADER Header;         // Common to all commands
    IANS_BD_PARAM_STATUS Status;
} IANS_BD_IOC_PARAM_STATUS, *PIANS_BD_IOC_PARAM_STATUS;

/*--------------------------------------------------------------------*
 | Indication
 | ==========
 | This enum value is sent by the notify call back function
 | called by the base driver for indication purposes.
 *--------------------------------------------------------------------*/
typedef enum _IANS_INDICATION {
    // ---------- Basic Extention Indications ---------- //
    IANS_IND_EXT_HWMODIFY,
    IANS_IND_EXT_STATUS_CHANGE, //Report a new status
    IANS_IND_XMIT_QUEUE_FULL,   // start transmit through this member
    IANS_IND_XMIT_QUEUE_READY,  // stop transmit through this member
    IANS_IND_COMMA              // Dummy to satisfy last ifdef'ed commma
} IANS_INDICATION, *PIANS_INDICATION;

typedef struct _IANS_BD_ANS_SET_CB {
    IANS_BD_PARAM_HEADER Header;
    void *notify;
} IANS_BD_ANS_SET_CB, *PIANS_BD_ANS_SET_CB;

/*--------------------------------------------------------------------*
 | Identify yourself struct
 | ========================
 | This struct is sent with the IANS_BD_IDENTIFY request.
 | iANS fills its signature string and version number, and sends it to
 | the base driver. The base driver fills its own signature string and
 | version and returns it.
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_IDENTIFY {
    IANS_BD_PARAM_HEADER Header;                // Common to all commands
    UCHAR iANSSignature[IANS_SIGNATURE_LENGTH]; // iANS fills copyright string
    UCHAR BDSignature[IANS_SIGNATURE_LENGTH];   // BD fills copyright string
    UINT32 iANSCommVersion;                     // iANS supported comm. version
                                                // Upper word = major version number
                                                // lower word = minor version number
    UINT32 BDCommVersion;                       // Base driver supported comm. version
} IANS_BD_PARAM_IDENTIFY, *PIANS_BD_PARAM_IDENTIFY;

/*--------------------------------------------------------------------*
 | Get Extended capabilities parameters struct
 | ===========================================
 | This struct is sent with IANS_OP_EXT_GET_CAPABILITY - to be filled
 | by the base driver and sent to iANS
 *--------------------------------------------------------------------*/
#define IANS_BD_FLAG1   0x0001
#define IANS_BD_FLAG2   0x0002
#define IANS_BD_FLAG3   0x0004
#define IANS_BD_FLAG4   0x0008
#define IANS_BD_FLAG5   0x0010
#define IANS_BD_FLAG6   0x0020
#define IANS_BD_FLAG7   0x0040
#define IANS_BD_FLAG8   0x0080


typedef struct _IANS_BD_PARAM_EXT_CAP {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 BDCanSetMacAddress;      // MAC Address setting - cast from IANS_BD_SUPPORT
    UINT32 BDIansStatusVersion;     // Status indication with iANS struct - which version is supported
    UINT32 BDAllAvailableRouting;   // Bitmask of all available Rx/Event * routings. IANS_BD_ROUTING
    UINT32 BDFlags;                 // The adapter's flags
    UINT32 BDAllAvailableSpeeds;    // A bit mask of all available speeds
} IANS_BD_PARAM_EXT_CAP, *PIANS_BD_PARAM_EXT_CAP;

/*--------------------------------------------------------------------*
 | Set Extended mode parameters struct
 | ===================================
 | This struct is sent with IANS_OP_EXT_SET_MODE - to be filled
 | by iANS and sent to the base driver
 |
 | iANS tells the base driver whether to report its status through
 | the extended struct or not.
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_EXT_SET_MODE {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 BDIansStatusReport;      // Ask the base driver to report status through
                                    // status struct.
                                    // Cast from IANS_BD_REQUEST.
    UINT32 BDIansAttributedMode;    // Ask the base driver to send and receive
                                    // packets accompanied by a per-frame data structure
                                    // Cast from IANS_BD_REQUEST.
    UINT32 BDIansRoutingMode;       // Bitmask of one Rx and one IANS_BD_ROUTING
} IANS_BD_PARAM_EXT_SET_MODE, *PIANS_BD_PARAM_EXT_SET_MODE;

/*--------------------------------------------------------------------*
 | Get Vlan tagging capabilities
 | =============================
 | This struct is sent with the IANS_OP_ITAG_GET_CAPABILITY ioctl, to be filled
 | by the base driver.
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_ITAG_CAP {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 ISLTagMode;              // cast from IANS_BD_SUPPORT
    UINT32 IEEE802_3acTagMode;      // cast from IANS_BD_SUPPORT
} IANS_BD_PARAM_ITAG_CAP, *PIANS_BD_PARAM_ITAG_CAP;

/*--------------------------------------------------------------------*
| Set Vlan tagging mode
| =====================
| This struct is sent with the IANS_OP_ITAG_SET_MODE ioctl, to be filled
| by iANS.
*--------------------------------------------------------------------*/
typedef enum _IANS_BD_TAGGING_MODE {
    IANS_BD_TAGGING_NONE =0,
    IANS_BD_TAGGING_802_3AC,
    IANS_BD_TAGGING_ISL,
    IANS_BD_TAGGING_UNDEFINED
}IANS_BD_TAGGING_MODE, *PIANS_BD_TAGGING_MODE ;

typedef struct _IANS_BD_PARAM_ITAG_SET_MODE {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 SetTagMode;              // cast from IANS_BD_TAGGING_MODE
} IANS_BD_PARAM_ITAG_SET_MODE, *PIANS_BD_PARAM_ITAG_SET_MODE;

/*--------------------------------------------------------------------*
 | Get Vlan ID capabilities
 | ========================
 | This struct is sent with the IANS_OP_IVLAN_ID_GET_CAPABILITY ioctl,
 | to be filled by the base driver
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_IVLAN_CAP {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 VlanIDCapable;           // Cast from IANS_BD_SUPPORT
    UINT32 VlanIDFilteringAble;     // Cast from IANS_BD_SUPPORT
    UINT16 MaxVlanIDSupported;      // Max. VLan ID supported by BD
    UINT32 MaxVlanTableSize;        // Max. number of VLan IDs in a table
} IANS_BD_PARAM_IVLAN_CAP, *PIANS_BD_PARAM_IVLAN_CAP;

/*--------------------------------------------------------------------*
 | Set Vlan ID mode
 | ================
 | This struct is sent with the IANS_OP_IVLAN_ID_SET_MODE ioctl, filled
 | by the iANS
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_IVLAN_SET_MODE {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 VlanIDRequest;           // Cast from IANS_BD_REQUEST
    UINT32 VlanIDFilteringRequest;  // Cast from IANS_BD_REQUEST
} IANS_BD_PARAM_IVLAN_SET_MODE, *PIANS_BD_PARAM_IVLAN_SET_MODE;

/*--------------------------------------------------------------------*
 | Set Vlan ID filtering table
 | ===========================
 | This struct is sent with the IANS_OP_IVLAN_ID_SET_TABLE request
 *--------------------------------------------------------------------*/
typedef struct _IANS_BD_PARAM_IVLAN_TABLE {
    IANS_BD_PARAM_HEADER Header;    // Common to all commands
    UINT32 VLanIDNum;               // Number of VLan IDs defined in this table
    UINT16 *VLanIDTable;            // Pointer to VLan ID table.
                                    // iANS will dynamically allocate
                                    // this table - we don't want to
                                    // force this struct to be
                                    // as big as the maximum number of
                                    // VLan IDs.
} IANS_BD_PARAM_IVLAN_TABLE, *PIANS_BD_PARAM_IVLAN_TABLE;

/*--------------------------------------------------------------------*
 | PER_FRAME_ATTRIBUE_HEADER
 | =========================
 | This header will be included in every TLV
 *--------------------------------------------------------------------*/
typedef struct _Per_Frame_Attribute_Header {
    UINT32 AttributeID;     // Indicates which kind of data is contained in this field
    UINT32 AttributeLength; // Length of this attribute
} Per_Frame_Attribute_Header, *pPer_Frame_Attribute_Header;


/*==========================================================================*
*                                                                           *
* Per-Message Attributes                                                    *
*                                                                           *
*==========================================================================*/

typedef struct _IANS_ATTR_HEADER {
    pPer_Frame_Attribute_Header pFirstTLV;  // NULL if not attributed
    UINT32 OriginalProtocol;
} IANS_ATTR_HEADER, *PIANS_ATTR_HEADER;

/*--------------------------------------------------------------------*
 | Attribute IDs
 | =============
 | These values indicate which type of attribute is contained in a
 | certain TLV.
 *--------------------------------------------------------------------*/
typedef enum _iANS_Attribute_ID {
    IANS_ATTR_LAST_ATTR=0,              // Marks the last attribute in a list
    IANS_ATTR_DUMMY,                    // Non-initiating side should ignore this attribute
    IANS_ATTR_VLAN_FIRST = 0x100,       // skip over reserved area
    IANS_ATTR_VLAN_ID,                  // This attribute contains the VLan ID
    IANS_ATTR_TAGGING_FIRST = 0x200,    // skip over reserved area
    IANS_ATTR_TAGGING_UNTAGGED,         // This determines that frame is untagged
    IANS_ATTR_COMMA
} iANS_Attribute_ID, *piANS_Attribute_ID;


/*-------------------------------------------------------------------
| VLAN_ID_PER_FRAME_INFO
| ======================
| This structure contains only the VLanID per-frame information.
 -------------------------------------------------------------------*/
typedef struct _VLAN_ID_Per_Frame_Info {
    Per_Frame_Attribute_Header AttrHeader;
    UINT16 VLanID;
    UCHAR Padding[2];
} VLAN_ID_Per_Frame_Info, *pVLAN_ID_Per_Frame_Info ;

/*-------------------------------------------------------------------
| Untagged_Attribute
| ==================
| This structure is for the "untagged" attribute(used to indicate
| that frame is untagged).
 -------------------------------------------------------------------*/
typedef struct _Untagged_Attribute {
    Per_Frame_Attribute_Header AttrHeader;
} Untagged_Attribute, *pUntagged_Attribute ;

/*-------------------------------------------------------------------
| LAST_ATTRIBUTE
| ==============
| This structure is for the last attribute in the TLV list.
 -------------------------------------------------------------------*/
typedef struct _Last_Attribute {
    Per_Frame_Attribute_Header LastHeader;
} Last_Attribute, *pLast_Attribute ;


/*==========================================================================*
*                                                                           *
* Rx Routing                                                                *
*                                                                           *
*==========================================================================*/

#define IANS_FRAME_TYPE     0x6D88  // Network order is 0x886D

// Restore packing mode.
#pragma pack()


#endif //_BASE_COMM_H

