Name: iANS
Summary: Intel(R) Advanced Network Services for Linux
Version: 2.0.12
Release: %(awk '{ print tolower($0) }' /etc/redhat-release | sed '{ s/.* \([0-9][^ ]*\).*/rh\1/; s/\.//g; }' || echo 1)
Source: iANS-2.0.12.tar.gz
Vendor: Intel Corporation
License: Proprietary
ExclusiveOS: linux
Group: System Environment/Kernel
Requires: kernel                                                               
Provides: %{name}
URL: http://support.intel.com/support/go/linux/ans.htm
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
This package contains the Intel(R) Advanced Network Services
driver for Linux. The driver provides advanced features including
Adapter Fault Tolerance, Adaptive Load Balancing, FEC/GEC/802.3ad
Link Aggregation and IEEE 802.3ac VLAN support.

%prep
%setup

%build
mkdir -p %{buildroot}

SwitchRHKernel () {
	CFLAGS_EXTRA=""
	for K in $2 ; do
		if [ $K == $1 ] ; then
			CFLAGS_EXTRA="$CFLAGS_EXTRA -D__BOOT_KERNEL_$K=1"
		else
			CFLAGS_EXTRA="$CFLAGS_EXTRA -D__BOOT_KERNEL_$K=0"
		fi
	done
}

KV=$(uname -r)

KSP="/lib/modules/$KV/build
     /usr/src/linux-$KV
     /usr/src/linux-$(echo $KV | sed 's/-.*//')
     /usr/src/kernel-headers-$KV
     /usr/src/kernel-source-$KV
     /usr/src/linux-$(echo $KV | sed 's/\([0-9]*\.[0-9]*\)\..*/\1/')
     /usr/src/linux"

KSRC=$(for d in $KSP ; do [ -e $d/include/linux ] && echo $d; echo;  done)
KSRC=$(echo $KSRC | awk '{ print $1 }')

if [ -e $KSRC/include/linux/rhconfig.h ] ; then
	RHKL=$(grep 'BOOT_KERNEL_.* [01]' /boot/kernel.h |
	       sed 's/.*BOOT_KERNEL_\(.*\) [01]/\1/')
	for K in $RHKL ; do
		SwitchRHKernel $K "$RHKL"
		make -C src veryclean
		make -C src INSTALL_ROOT=%{buildroot} \
			MAN_DIR=%{_mandir} CFLAGS_EXTRA="$CFLAGS_EXTRA" install
	done
	install -D -m 544 install_scripts/Redhat/ans %{buildroot}/etc/init.d/ans
else
	make -C src veryclean
	make -C src INSTALL_ROOT=%{buildroot} MAN_DIR=%{_mandir} install
fi

%install
cd %{buildroot}
find . -name modules.* -exec rm -f {} \;
find . -type f -fprintf %{_builddir}/%{name}-%{version}/file.list "/%p\n"

%clean
rm -rf %{buildroot}

%files -f %{_builddir}/%{name}-%{version}/file.list
%defattr(-,root,root)
%doc LICENSE
%doc README
%doc ldistrib.txt
%doc file.list

%post
uname -r | grep BOOT || /sbin/depmod -aqs > /dev/null 2>&1 || true

%postun
uname -r | grep BOOT || /sbin/depmod -aqs > /dev/null 2>&1 || true
